<template>
  <div class="custom-page">
    <template v-if="page && page.pages_contents[0]">
      <h1>{{ page.pages_contents[0].title }}</h1>
      <div v-html="page.pages_contents[0].content"></div>
      <div
        class="custom-page-block"
        v-for="(block, index) in page.pages_contents[0].pages_contents_blocks"
        :id="block.hash"
        :key="index"
      >
        <h2 class="custom-page-block__title">{{ block.title }}</h2>
        <div
          class="custom-page-block__content"
          v-html="filterTabs(block.content)"
        ></div>
      </div>
    </template>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  watch,
  useAsync,
  useMeta
} from '@nuxtjs/composition-api'
import { useGetPageQuery } from '@/sdk/hooks'

import useSeo from '@/hooks/seo'
import useGetLocales from '@/hooks/get-locales'
import { FullPageFragment } from '~/sdk/types'

export default defineComponent({
  layout: 'page',
  name: 'CustomPage',
  head: {},
  setup(_, { root }) {
    const { app, route, error } = useContext()

    const slug =
      root.$i18n.locale !== 'en'
        ? route.value.path.replace(`/${root.$i18n.locale}`, '')
        : route.value.path

    const { onResult, loading } = useGetPageQuery(
      {
        slug,
        locales: useGetLocales(app.i18n)
      },
      {
        fetchPolicy: 'network-only'
      }
    )

    const meta = useMeta()
    const page = useAsync<FullPageFragment>(
      () =>
        new Promise(resolve =>
          onResult(result => {
            if (!result?.data?.pages?.[0]?.pages_contents?.[0]) {
              error({ statusCode: 404 })
              return resolve()
            }
            const page = result.data.pages[0]
            useSeo(page, app.$accessor.seo.default, meta, app.i18n.locale)
            resolve(page)
          })
        )
    )

    if (process.client) {
      onResult(result => {
        if (!result?.data?.pages?.[0]?.pages_contents?.[0]) {
          return error({ statusCode: 404 })
        }
        page.value = result.data.pages[0]
        useSeo(page.value, app.$accessor.seo.default, meta, app.i18n.locale)
      })

      watch([page, route], () => {
        if (!route.value.hash) return
        root.$scrollTo(route.value.hash, {
          offset: -85
        })
      })
    }

    const filterTabs = (date: any) => {
      if (process.client) {
        date = date
          .replace(/<table[^>]*>/g, '<div class="scroll-table"><table>')
          .replace(/<\/table>/g, '</table></div>')
        return date
      } else {
        return date
      }
    }

    return { filterTabs, page, loading }
  }
})
</script>

<style lang="scss" scoped>
.custom-page {
  margin-bottom: 150px;
  color: #9badd6;
  font-size: 20px;
  line-height: 28px;
  letter-spacing: 0px;
  word-break: break-word;
  @media (min-width: 1199.98px) {
    max-width: 80%;
    margin-bottom: 150px;
    color: #9badd6;
    font-size: 24px;
    line-height: 38px;
    letter-spacing: 0px;
  }

  ::v-deep h1 {
    font-weight: normal;
    font-size: 40px;
    line-height: 45px;
    letter-spacing: -1px;
    color: #ffffff;
    margin: 0 0 50px 0;
    @media (min-width: 1199.98px) {
      font-size: 55px;
      line-height: 55px;
      letter-spacing: -1.38px;
      margin: 0 0 95px 0;
    }
  }

  .custom-page-block {
    margin-bottom: 50px;
    @media (min-width: 1199.98px) {
      margin-bottom: 100px;
    }
  }

  ::v-deep {
    .scroll-table {
      overflow-x: auto;
      overflow-y: hidden;
      white-space: nowrap;
    }
    h2 {
      font-size: 30px;
      line-height: 36px;
      font-weight: normal;
      color: #ffffff;
      margin: 0 0 25px 0;
      padding: 0;
      position: relative;

      &:before {
        content: '';
        display: block;
        width: 60px;
        height: 2px;
        background: #00ffb3;
        margin-bottom: 30px;
      }

      @media (min-width: 1199.98px) {
        font-size: 40px;
        line-height: 36px;
        margin: 0 0 30px 0;
        padding: 0 0 0 90px;
        &:before {
          content: '';
          position: absolute;
          left: 0;
          top: 20px;
          margin-bottom: 0px;
        }
      }
    }

    h3 {
      color: #fff;
      font-weight: normal;
      margin: 0 0 25px 0;
      padding: 0;
      position: relative;
    }

    p {
      margin-top: 0px;
      margin-bottom: 30px;

      &:last-child {
        margin-bottom: 0px;
      }
    }

    a {
      color: #00ffb3;
      text-decoration: none;
      cursor: pointer;
      text-decoration: none;
      background-image: linear-gradient(
        0deg,
        currentColor 100%,
        rgba(32, 126, 150, 0)
      );
      background-size: 0 1px;
      padding-bottom: 2px;
      background-position: 200% 100%;
      background-repeat: no-repeat;
      transform-origin: left bottom;
      transition: background-size 0.5s ease,
        background-position 0.6s ease-out 0.1s, color 0.5s ease;
      &:hover {
        background-size: 100% 1px;
        background-position: 0 100%;
        animation: underline-hover forwards;
        animation-duration: 0.3s;
      }
    }

    strong {
      color: #fff;
    }
    table {
      border: 1px solid #495271;
      width: 100%;
      margin: 0;
      padding: 0;
      border-collapse: collapse;
      border-spacing: 0;

      tr {
        border: 1px solid #495271;
        padding: 5px;
      }

      th,
      td {
        padding: 20px;
        text-align: center;
        border-right: 1px solid #495271;
      }

      th {
        background-color: #495271;
        font-weight: normal;
      }
    }
  }
}
</style>
